// Type definitions for @nginstack/engine 58.0
// Project: https://dev.azure.com/nginstack/nginstack
// Definitions by: Renato Ribeiro <https://github.com/Henato>
//                 Paulo Moreno <https://github.com/paulocmoreno>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
// Minimum TypeScript Version: 4.3
/// <reference path="context/connection.d.ts" />
/// <reference path="context/database.d.ts" />
/// <reference path="context/engine.d.ts" />
/// <reference path="context/index.d.ts" />
/// <reference path="context/repository.d.ts" />
/// <reference path="context/request.d.ts" />
/// <reference path="context/response.d.ts" />
/// <reference path="context/session.d.ts" />
/// <reference path="context/tempDB.d.ts" />
/// <reference path="context/vendor.d.ts" />
/// <reference path="keys/Classes.d.ts" />
/// <reference path="keys/DateFormats.d.ts" />
/// <reference path="keys/Engines.d.ts" />
/// <reference path="keys/Files.d.ts" />
/// <reference path="keys/Groups.d.ts" />
/// <reference path="keys/LogTypes.d.ts" />
/// <reference path="keys/MimeTypes.d.ts" />
/// <reference path="keys/PermissionApplyModes.d.ts" />
/// <reference path="keys/Products.d.ts" />
/// <reference path="keys/Roles.d.ts" />
/// <reference path="keys/Users.d.ts" />
/// <reference path="keys/UserStatus.d.ts" />
/// <reference path="lib/array/argumentsToArray.d.ts" />
/// <reference path="lib/array/arrayEquals.d.ts" />
/// <reference path="lib/array/flatten.d.ts" />
/// <reference path="lib/array/listToArray.d.ts" />
/// <reference path="lib/array/remove.d.ts" />
/// <reference path="lib/array/removeAt.d.ts" />
/// <reference path="lib/barcode/Barcode.d.ts" />
/// <reference path="lib/classdef/AfterPersistEvent.d.ts" />
/// <reference path="lib/classdef/BeforePersistEvent.d.ts" />
/// <reference path="lib/classdef/ClassDef.d.ts" />
/// <reference path="lib/classdef/ClassDefCache.d.ts" />
/// <reference path="lib/classdef/ClassDefManager.d.ts" />
/// <reference path="lib/classdef/ClassSourceGenerator.d.ts" />
/// <reference path="lib/classdef/ConfigDef.d.ts" />
/// <reference path="lib/classdef/DataEvent.d.ts" />
/// <reference path="lib/classdef/Field.d.ts" />
/// <reference path="lib/classdef/FieldChangeEvent.d.ts" />
/// <reference path="lib/classdef/FieldEvent.d.ts" />
/// <reference path="lib/classdef/FieldGroup.d.ts" />
/// <reference path="lib/classdef/FieldList.d.ts" />
/// <reference path="lib/classdef/FieldNameList.d.ts" />
/// <reference path="lib/classdef/FieldOptionsEvent.d.ts" />
/// <reference path="lib/classdef/getImageRelationConfig.d.ts" />
/// <reference path="lib/classdef/getLookupDataClass.d.ts" />
/// <reference path="lib/classdef/getLookupDisplayValue.d.ts" />
/// <reference path="lib/classdef/InterceptorConfiguration.d.ts" />
/// <reference path="lib/classdef/LookupAddResultEvent.d.ts" />
/// <reference path="lib/classdef/LookupDisplayEvent.d.ts" />
/// <reference path="lib/classdef/LookupType.d.ts" />
/// <reference path="lib/classdef/MasterDeleteAction.d.ts" />
/// <reference path="lib/classdef/ModelDef.d.ts" />
/// <reference path="lib/classdef/PermissionField.d.ts" />
/// <reference path="lib/classdef/PermissionFieldScope.d.ts" />
/// <reference path="lib/classdef/PersistEvent.d.ts" />
/// <reference path="lib/classdef/ReadOnlyMode.d.ts" />
/// <reference path="lib/classdef/reduceFieldDefs.d.ts" />
/// <reference path="lib/classdef/SessionConfiguration.d.ts" />
/// <reference path="lib/classdef/SessionEnvironmentType.d.ts" />
/// <reference path="lib/classdef/SessionPersistence.d.ts" />
/// <reference path="lib/classdef/sortFieldsByOrder.d.ts" />
/// <reference path="lib/classdef/SourceType.d.ts" />
/// <reference path="lib/classdef/StrictModeEvaluator.d.ts" />
/// <reference path="lib/classdef/TableCacheStrategy.d.ts" />
/// <reference path="lib/compiler/ijs/JSScanner.d.ts" />
/// <reference path="lib/compiler/ijs/JSSpecialWord.d.ts" />
/// <reference path="lib/compiler/ijs/JSTokenType.d.ts" />
/// <reference path="lib/compiler/ijs/JSTokenWord.d.ts" />
/// <reference path="lib/compress/GzipFile.d.ts" />
/// <reference path="lib/compress/jsmin.d.ts" />
/// <reference path="lib/compress/ZipFile.d.ts" />
/// <reference path="lib/compress/Zlib.d.ts" />
/// <reference path="lib/connection/Connection.d.ts" />
/// <reference path="lib/crypto/Crypto.d.ts" />
/// <reference path="lib/crypto/CryptoPKey.d.ts" />
/// <reference path="lib/crypto/DigestType.d.ts" />
/// <reference path="lib/crypto/DSACryptoPKey.d.ts" />
/// <reference path="lib/crypto/ECCryptoPKey.d.ts" />
/// <reference path="lib/crypto/MD5.d.ts" />
/// <reference path="lib/crypto/RSACryptoPKey.d.ts" />
/// <reference path="lib/crypto/SHA1.d.ts" />
/// <reference path="lib/crypto/SHA256.d.ts" />
/// <reference path="lib/crypto/SHA512.d.ts" />
/// <reference path="lib/database/Classes.d.ts" />
/// <reference path="lib/database/Database.d.ts" />
/// <reference path="lib/database/DatabaseDataType.d.ts" />
/// <reference path="lib/database/databaseToDataSetDataType.d.ts" />
/// <reference path="lib/database/DBBackup.d.ts" />
/// <reference path="lib/database/DBCache.d.ts" />
/// <reference path="lib/database/DBTracker.d.ts" />
/// <reference path="lib/database/DBTrackerPool.d.ts" />
/// <reference path="lib/database/KeyPrefetcher.d.ts" />
/// <reference path="lib/database/KeysUtilities.d.ts" />
/// <reference path="lib/database/LargeObject.d.ts" />
/// <reference path="lib/database/Limits.d.ts" />
/// <reference path="lib/database/LobStorage.d.ts" />
/// <reference path="lib/database/LogDatumIterator.d.ts" />
/// <reference path="lib/database/QueryUtilities.d.ts" />
/// <reference path="lib/database/SystemFields.d.ts" />
/// <reference path="lib/dataset/ApplyUpdatesAction.d.ts" />
/// <reference path="lib/dataset/canApplyUpdates.d.ts" />
/// <reference path="lib/dataset/ClientDataSet.d.ts" />
/// <reference path="lib/dataset/DataSet.d.ts" />
/// <reference path="lib/dataset/DataSetDataType.d.ts" />
/// <reference path="lib/dataset/dataSetEquals.d.ts" />
/// <reference path="lib/dataset/DataSetManager.d.ts" />
/// <reference path="lib/dataset/DataSetManagerError.d.ts" />
/// <reference path="lib/dataset/DataSetStates.d.ts" />
/// <reference path="lib/dataset/DataSetTransformer.d.ts" />
/// <reference path="lib/dataset/DeltaDumper.d.ts" />
/// <reference path="lib/dataset/DeltaInspector.d.ts" />
/// <reference path="lib/dataset/fieldValueIsEqual.d.ts" />
/// <reference path="lib/dataset/fieldValuesAreEqual.d.ts" />
/// <reference path="lib/dataset/findFields.d.ts" />
/// <reference path="lib/dataset/forceRecordUpdate.d.ts" />
/// <reference path="lib/dataset/forEachRecord.d.ts" />
/// <reference path="lib/dataset/getDistinctValues.d.ts" />
/// <reference path="lib/dataset/GetFieldOptions.d.ts" />
/// <reference path="lib/dataset/getFieldValues.d.ts" />
/// <reference path="lib/dataset/getFirstFieldValue.d.ts" />
/// <reference path="lib/dataset/hasEmptyRange.d.ts" />
/// <reference path="lib/dataset/isTextualField.d.ts" />
/// <reference path="lib/dataset/pruneTree.d.ts" />
/// <reference path="lib/dataset/rangeEquals.d.ts" />
/// <reference path="lib/dataset/RecordIterator.d.ts" />
/// <reference path="lib/dataset/recordToJson.d.ts" />
/// <reference path="lib/dataset/recordToObject.d.ts" />
/// <reference path="lib/dataset/setEmptyRange.d.ts" />
/// <reference path="lib/dataset/syncIndexAndFilters.d.ts" />
/// <reference path="lib/dataset/syncRecords.d.ts" />
/// <reference path="lib/dataset/Transaction.d.ts" />
/// <reference path="lib/date/checkRange.d.ts" />
/// <reference path="lib/date/dateCompare.d.ts" />
/// <reference path="lib/date/DateFormat.d.ts" />
/// <reference path="lib/date/Duration.d.ts" />
/// <reference path="lib/date/fieldsToDate.d.ts" />
/// <reference path="lib/date/firstMonthDayOf.d.ts" />
/// <reference path="lib/date/firstWeekDayOf.d.ts" />
/// <reference path="lib/date/formatDate.d.ts" />
/// <reference path="lib/date/formatElapsedTime.d.ts" />
/// <reference path="lib/date/formatTime.d.ts" />
/// <reference path="lib/date/getInterval.d.ts" />
/// <reference path="lib/date/getNumberOfDaysInMonth.d.ts" />
/// <reference path="lib/date/getWeekNumber.d.ts" />
/// <reference path="lib/date/incDate.d.ts" />
/// <reference path="lib/date/incMonth.d.ts" />
/// <reference path="lib/date/incYear.d.ts" />
/// <reference path="lib/date/isLeapYear.d.ts" />
/// <reference path="lib/date/Month.d.ts" />
/// <reference path="lib/date/parseDate.d.ts" />
/// <reference path="lib/date/parseISO8601Date.d.ts" />
/// <reference path="lib/date/phpFormatDate.d.ts" />
/// <reference path="lib/date/setDateWithTimeString.d.ts" />
/// <reference path="lib/date/skipHoliday.d.ts" />
/// <reference path="lib/date/truncateTimePart.d.ts" />
/// <reference path="lib/date/WeekDay.d.ts" />
/// <reference path="lib/dbkey/DBKey.d.ts" />
/// <reference path="lib/dom/Attr.d.ts" />
/// <reference path="lib/dom/CDATASection.d.ts" />
/// <reference path="lib/dom/CharacterData.d.ts" />
/// <reference path="lib/dom/Comment.d.ts" />
/// <reference path="lib/dom/Document.d.ts" />
/// <reference path="lib/dom/DocumentFragment.d.ts" />
/// <reference path="lib/dom/DocumentType.d.ts" />
/// <reference path="lib/dom/DOMImplementation.d.ts" />
/// <reference path="lib/dom/DOMString.d.ts" />
/// <reference path="lib/dom/Element.d.ts" />
/// <reference path="lib/dom/Entity.d.ts" />
/// <reference path="lib/dom/EntityReference.d.ts" />
/// <reference path="lib/dom/NamedNodeMap.d.ts" />
/// <reference path="lib/dom/Node.d.ts" />
/// <reference path="lib/dom/NodeList.d.ts" />
/// <reference path="lib/dom/Notation.d.ts" />
/// <reference path="lib/dom/ProcessingInstruction.d.ts" />
/// <reference path="lib/dom/Text.d.ts" />
/// <reference path="lib/encoding/Base64.d.ts" />
/// <reference path="lib/encoding/Base85.d.ts" />
/// <reference path="lib/encoding/Encoder.d.ts" />
/// <reference path="lib/encoding/Hex.d.ts" />
/// <reference path="lib/encoding/numberToHex.d.ts" />
/// <reference path="lib/engine/Engine.d.ts" />
/// <reference path="lib/engine/MemoryManager.d.ts" />
/// <reference path="lib/error/DetailedError.d.ts" />
/// <reference path="lib/error/DetailedErrorBase.d.ts" />
/// <reference path="lib/error/FatalError.d.ts" />
/// <reference path="lib/error/getStackTrace.d.ts" />
/// <reference path="lib/error/NativeDetailedErrorWrapper.d.ts" />
/// <reference path="lib/event/Adapter.d.ts" />
/// <reference path="lib/event/AdapterDescriptor.d.ts" />
/// <reference path="lib/event/DuplicationHandling.d.ts" />
/// <reference path="lib/event/Emitter.d.ts" />
/// <reference path="lib/event/Event.d.ts" />
/// <reference path="lib/event/EventTypeError.d.ts" />
/// <reference path="lib/event/LegacyEvent.d.ts" />
/// <reference path="lib/event/LegacyMethod.d.ts" />
/// <reference path="lib/event/Listener.d.ts" />
/// <reference path="lib/event/ListenerCompareFunctions.d.ts" />
/// <reference path="lib/event/SurrogateListener.d.ts" />
/// <reference path="lib/file-storage/FileInfo.d.ts" />
/// <reference path="lib/file-storage/FileStorage.d.ts" />
/// <reference path="lib/filesync/FileSynchronizer.d.ts" />
/// <reference path="lib/format/formatFileSize.d.ts" />
/// <reference path="lib/format/numBytesToString.d.ts" />
/// <reference path="lib/format/numericValueToString.d.ts" />
/// <reference path="lib/function/Args.d.ts" />
/// <reference path="lib/function/ArgsError.d.ts" />
/// <reference path="lib/function/ArgsGetMode.d.ts" />
/// <reference path="lib/gcp/IDToken.d.ts" />
/// <reference path="lib/geo/AngleFormat.d.ts" />
/// <reference path="lib/geo/formatAngle.d.ts" />
/// <reference path="lib/geo/formatLatitude.d.ts" />
/// <reference path="lib/geo/formatLongitude.d.ts" />
/// <reference path="lib/geo/LatitudeFormat.d.ts" />
/// <reference path="lib/geo/LongitudeFormat.d.ts" />
/// <reference path="lib/geo/parseAngle.d.ts" />
/// <reference path="lib/geo/parseLatitude.d.ts" />
/// <reference path="lib/geo/parseLongitude.d.ts" />
/// <reference path="lib/global/exportSymbol.d.ts" />
/// <reference path="lib/global/global.d.ts" />
/// <reference path="lib/hash/superFastHash.d.ts" />
/// <reference path="lib/html/HtmlSanitizer.d.ts" />
/// <reference path="lib/http/Accepts.d.ts" />
/// <reference path="lib/http/Header.d.ts" />
/// <reference path="lib/http/HttpError.d.ts" />
/// <reference path="lib/http/MediaType.d.ts" />
/// <reference path="lib/http/Method.d.ts" />
/// <reference path="lib/http/RealmConfig.d.ts" />
/// <reference path="lib/http/Request.d.ts" />
/// <reference path="lib/http/RequestBody.d.ts" />
/// <reference path="lib/http/Response.d.ts" />
/// <reference path="lib/http/ServerId.d.ts" />
/// <reference path="lib/http/Status.d.ts" />
/// <reference path="lib/i18n/NumberFormat.d.ts" />
/// <reference path="lib/i18n/ResourceString.d.ts" />
/// <reference path="lib/i18n/symbols/pt-BR.d.ts" />
/// <reference path="lib/ido/IdoDB.d.ts" />
/// <reference path="lib/ido/IdoDBManager.d.ts" />
/// <reference path="lib/image/getMainImageUrl.d.ts" />
/// <reference path="lib/io/File.d.ts" />
/// <reference path="lib/io/MemoryStream.d.ts" />
/// <reference path="lib/io/SearchRecord.d.ts" />
/// <reference path="lib/io/SerialPort.d.ts" />
/// <reference path="lib/java/Enginelet.d.ts" />
/// <reference path="lib/java/JavaImporter.d.ts" />
/// <reference path="lib/java/JavaRequest.d.ts" />
/// <reference path="lib/java/JavaServer.d.ts" />
/// <reference path="lib/jaz/listJazPackages.d.ts" />
/// <reference path="lib/jose/JWS.d.ts" />
/// <reference path="lib/license/LicenseManager.d.ts" />
/// <reference path="lib/log/Logger.d.ts" />
/// <reference path="lib/mail/Mail.d.ts" />
/// <reference path="lib/mail/MailMessage.d.ts" />
/// <reference path="lib/mail/MailMessageHeader.d.ts" />
/// <reference path="lib/mail/MailMessagePart.d.ts" />
/// <reference path="lib/mail/Pop3.d.ts" />
/// <reference path="lib/math/BigDecimal.d.ts" />
/// <reference path="lib/math/decimalRound.d.ts" />
/// <reference path="lib/math/isInteger.d.ts" />
/// <reference path="lib/math/isNumber.d.ts" />
/// <reference path="lib/math/isZero.d.ts" />
/// <reference path="lib/math/round.d.ts" />
/// <reference path="lib/math/RoundingMode.d.ts" />
/// <reference path="lib/math/trunc.d.ts" />
/// <reference path="lib/mime/isTextualType.d.ts" />
/// <reference path="lib/multipart/MultipartFormData.d.ts" />
/// <reference path="lib/multipart/MultipartFormDataOptions.d.ts" />
/// <reference path="lib/multipart/MultipartFormDataPart.d.ts" />
/// <reference path="lib/multipart/MultipartFormDataReader.d.ts" />
/// <reference path="lib/multipart/MultipartFormFile.d.ts" />
/// <reference path="lib/net/downloadFile.d.ts" />
/// <reference path="lib/net/NetworkUtilities.d.ts" />
/// <reference path="lib/net/Socket.d.ts" />
/// <reference path="lib/net/WebSocket.d.ts" />
/// <reference path="lib/net/XMLHttpRequest.d.ts" />
/// <reference path="lib/oauth2/OAuth2Client.d.ts" />
/// <reference path="lib/object/createSet.d.ts" />
/// <reference path="lib/object/declareProperty.d.ts" />
/// <reference path="lib/object/deepClone.d.ts" />
/// <reference path="lib/object/deserialize.d.ts" />
/// <reference path="lib/object/every.d.ts" />
/// <reference path="lib/object/filter.d.ts" />
/// <reference path="lib/object/forEach.d.ts" />
/// <reference path="lib/object/getPropertyDescriptor.d.ts" />
/// <reference path="lib/object/hideFunctionSources.d.ts" />
/// <reference path="lib/object/inherits.d.ts" />
/// <reference path="lib/object/isEmpty.d.ts" />
/// <reference path="lib/object/isObject.d.ts" />
/// <reference path="lib/object/map.d.ts" />
/// <reference path="lib/object/PropertyMapper.d.ts" />
/// <reference path="lib/object/reduce.d.ts" />
/// <reference path="lib/object/serialize.d.ts" />
/// <reference path="lib/object/some.d.ts" />
/// <reference path="lib/object/toStringExpression.d.ts" />
/// <reference path="lib/oidc/OpenIdClient.d.ts" />
/// <reference path="lib/oidc/OpenIdProvider.d.ts" />
/// <reference path="lib/os/OSApplication.d.ts" />
/// <reference path="lib/phone/parsePhone.d.ts" />
/// <reference path="lib/phone/PhoneNumber.d.ts" />
/// <reference path="lib/print/HtmlToPdf.d.ts" />
/// <reference path="lib/print/Spool.d.ts" />
/// <reference path="lib/product/applyDisablingProductKeyCreation.d.ts" />
/// <reference path="lib/product/canRelateKeys.d.ts" />
/// <reference path="lib/product/getChangeableProducts.d.ts" />
/// <reference path="lib/product/getDependencies.d.ts" />
/// <reference path="lib/product/getProductFromKey.d.ts" />
/// <reference path="lib/product/ProductManager.d.ts" />
/// <reference path="lib/profiler/Profiler.d.ts" />
/// <reference path="lib/progress/applyWithIndeterminateProgress.d.ts" />
/// <reference path="lib/progress/applyWithProgress.d.ts" />
/// <reference path="lib/progress/Progress.d.ts" />
/// <reference path="lib/progress/ProgressMonitor.d.ts" />
/// <reference path="lib/progress/TaskProgressStatus.d.ts" />
/// <reference path="lib/progress/TaskProgressStatusArray.d.ts" />
/// <reference path="lib/range/Limit.d.ts" />
/// <reference path="lib/regexp/findFirstMatch.d.ts" />
/// <reference path="lib/regexp/findMatches.d.ts" />
/// <reference path="lib/regexp/Regex.d.ts" />
/// <reference path="lib/regexp/replaceAll.d.ts" />
/// <reference path="lib/repository/Repository.d.ts" />
/// <reference path="lib/router/Broker.d.ts" />
/// <reference path="lib/router/Controller.d.ts" />
/// <reference path="lib/router/ControllerEvent.d.ts" />
/// <reference path="lib/router/Route.d.ts" />
/// <reference path="lib/router/RouteDef.d.ts" />
/// <reference path="lib/router/RouteResult.d.ts" />
/// <reference path="lib/router/RouteSet.d.ts" />
/// <reference path="lib/router/RouteSetDef.d.ts" />
/// <reference path="lib/router/RoutesValidator.d.ts" />
/// <reference path="lib/runner/executeScript.d.ts" />
/// <reference path="lib/runner/ScriptRunner.d.ts" />
/// <reference path="lib/scheduler/Job.d.ts" />
/// <reference path="lib/scheduler/RemoteScheduler.d.ts" />
/// <reference path="lib/scheduler/Scheduler.d.ts" />
/// <reference path="lib/scheduler/Task.d.ts" />
/// <reference path="lib/schema/DatabaseSchema.d.ts" />
/// <reference path="lib/schema/DatabaseSchemaObserver.d.ts" />
/// <reference path="lib/schema/DataModelSchema.d.ts" />
/// <reference path="lib/security/AdministratorPasswordResetRequest.d.ts" />
/// <reference path="lib/security/AuthToken.d.ts" />
/// <reference path="lib/security/ClassChangePolicy.d.ts" />
/// <reference path="lib/security/FieldPermissions.d.ts" />
/// <reference path="lib/security/PasswordResetService.d.ts" />
/// <reference path="lib/security/PasswordRulesUtilities.d.ts" />
/// <reference path="lib/security/PermissionAssignment.d.ts" />
/// <reference path="lib/security/PermissionMaintenance.d.ts" />
/// <reference path="lib/security/PermissionManager.d.ts" />
/// <reference path="lib/security/PermissionMode.d.ts" />
/// <reference path="lib/security/PermissionSchema.d.ts" />
/// <reference path="lib/security/Security.d.ts" />
/// <reference path="lib/security/SecurityPolicy.d.ts" />
/// <reference path="lib/security/SecurityPolicyApplication.d.ts" />
/// <reference path="lib/session/Session.d.ts" />
/// <reference path="lib/session/SessionManager.d.ts" />
/// <reference path="lib/settings/GeneralSettings.d.ts" />
/// <reference path="lib/settings/SettingType.d.ts" />
/// <reference path="lib/sms/AspSms.d.ts" />
/// <reference path="lib/sms/HumanSms.d.ts" />
/// <reference path="lib/string/adjustCase.d.ts" />
/// <reference path="lib/string/capitalize.d.ts" />
/// <reference path="lib/string/escapeRegExp.d.ts" />
/// <reference path="lib/string/formatNumber.d.ts" />
/// <reference path="lib/string/formatNumberPrecision.d.ts" />
/// <reference path="lib/string/formatString.d.ts" />
/// <reference path="lib/string/htmlString.d.ts" />
/// <reference path="lib/string/identifierToName.d.ts" />
/// <reference path="lib/string/indexOfChars.d.ts" />
/// <reference path="lib/string/nameToIdentifier.d.ts" />
/// <reference path="lib/string/onlyNumbers.d.ts" />
/// <reference path="lib/string/padNumber.d.ts" />
/// <reference path="lib/string/padString.d.ts" />
/// <reference path="lib/string/removeAccents.d.ts" />
/// <reference path="lib/string/removeAt.d.ts" />
/// <reference path="lib/string/removeChars.d.ts" />
/// <reference path="lib/string/removeLineBreaks.d.ts" />
/// <reference path="lib/string/removePrefix.d.ts" />
/// <reference path="lib/string/removeSuffix.d.ts" />
/// <reference path="lib/string/replaceAll.d.ts" />
/// <reference path="lib/string/splitByCommaOrSemicolon.d.ts" />
/// <reference path="lib/string/stringCompare.d.ts" />
/// <reference path="lib/string/StringList.d.ts" />
/// <reference path="lib/string/stringToInt32.d.ts" />
/// <reference path="lib/string/stringToInteger.d.ts" />
/// <reference path="lib/string/stringToNumber.d.ts" />
/// <reference path="lib/string/toFormattedString.d.ts" />
/// <reference path="lib/string/toHtmlString.d.ts" />
/// <reference path="lib/string/toLowerCaseNoAccent.d.ts" />
/// <reference path="lib/string/toSqlIdentifier.d.ts" />
/// <reference path="lib/string/toSqlString.d.ts" />
/// <reference path="lib/string/toUpperCaseNoAccent.d.ts" />
/// <reference path="lib/string/validateString.d.ts" />
/// <reference path="lib/sync/activeWaitFor.d.ts" />
/// <reference path="lib/sync/CriticalSection.d.ts" />
/// <reference path="lib/sync/sleep.d.ts" />
/// <reference path="lib/sync/SyncEvent.d.ts" />
/// <reference path="lib/testing/assert.d.ts" />
/// <reference path="lib/testing/AssertionError.d.ts" />
/// <reference path="lib/testing/classdef/testModelDefs.d.ts" />
/// <reference path="lib/testing/classdef/testViewDefs.d.ts" />
/// <reference path="lib/testing/dataset/addFields.d.ts" />
/// <reference path="lib/testing/dataset/appendRecords.d.ts" />
/// <reference path="lib/testing/dataset/newDataSet.d.ts" />
/// <reference path="lib/testing/http/MockRequest.d.ts" />
/// <reference path="lib/testing/http/MockResponse.d.ts" />
/// <reference path="lib/testing/router/testRouteDefs.d.ts" />
/// <reference path="lib/testing/vfs/testIncludeOnce.d.ts" />
/// <reference path="lib/ufs/UnionFileSystem.d.ts" />
/// <reference path="lib/url/appendPath.d.ts" />
/// <reference path="lib/url/extractNameFromUrl.d.ts" />
/// <reference path="lib/url/URLSearchParams.d.ts" />
/// <reference path="lib/uuid/createGUID.d.ts" />
/// <reference path="lib/version/compareVersions.d.ts" />
/// <reference path="lib/vfs/VirtualFileSystem.d.ts" />
/// <reference path="lib/xml/formatCDATA.d.ts" />
/// <reference path="lib/xml/ReadElementTextBehaviour.d.ts" />
/// <reference path="lib/xml/ReadError.d.ts" />
/// <reference path="lib/xml/removeUnsupportedChars.d.ts" />
/// <reference path="lib/xml/TokenType.d.ts" />
/// <reference path="lib/xml/XMLStreamReader.d.ts" />
